;Tutorial 3 Sprungfunction
;Jetzt wollen wir die Steuerung hoch und runter gegen eine Sprungfunction
;austauschen.

Graphics 640,480

SetBuffer BackBuffer()
frametimer = CreateTimer (30)
ClsColor 0, 0, 255


Global tile = LoadImage ("tile2.bmp")
MaskImage tile, 255, 0, 255
Global dude = LoadImage ("dude.bmp")
MaskImage dude, 255, 0, 255


Global Player_pos_x = 200
Global Player_pos_y = 320
Global Player_temp_y# = 0   ;Das Zeichen # ist wichtig, da wir eine Kommazahl berechnen
Global jump
Global jumptimer#

Const rauf = 200, runter = 208, rechts = 205, links = 203, space = 57 




Dim map (20,15)

Restore mapdata
For y=0 To 14
	For x=0 To 19
		Read map(x,y)
	Next
Next



Repeat

Cls
WaitTimer (frametimer)

DrawMap()
MoveDude()
DoJump()
DrawPlayer()

Flip

Until KeyHit (1) 
End



Function DrawMap()
	For y = 0 To 14
		For x = 0 To 19
			If map(x,y) = 1 Then
				DrawImage tile, x*32, y*32
			EndIf 
		Next
	Next
End Function  


Function MoveDude()
	If KeyDown(links) Then	
		If map(Player_pos_x /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x -4
			If Player_pos_x =< 0 Then Player_pos_x = 1
		EndIf
	ElseIf KeyDown(rechts) Then
		If map((Player_pos_x +32) /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x +4
			If Player_pos_x => 608 Then Player_pos_x = 607
		EndIf
	EndIf 
	;Die Abfrage fr hoch und runter wurden entfernt.
End Function 


	
Function DoJump()
	;berprft ob Taste Space gedrckt wurde
	If KeyDown (space) Then
		If jump = False   ;wenn Variable jump = 0
			jump = True			;auf True setzen
			Player_temp_y = 15	 ;Die Sprunghhe setzen
		EndIf 
	EndIf
	
	;falls Player nach oben gegen Mauer springt, fllt er zurck
	If map((Player_pos_x +16) /32,Player_pos_y /32)=1 And jump = True Then
		jump = False
		Player_pos_y = Player_pos_y +1	;mu um eins tiefer gesetzt werden, da sonst die Figur hngen bleibt
	EndIf 
	
	 
	;die eigentliche Sprungroutine 
	If jump = True Then
		Player_temp_y = Player_temp_y -0.33    ;Die Temporre Variable verringern
		Player_pos_y = Player_pos_y - Player_temp_y ; Position Y durch TempY veringern
		; Solange Temp_y eine positive Zahl ist, bewegt sich unsere Figur hoch,
		; andernfalls runter.
								 	 															
		If Player_temp_y =< 0 Then   ; Sobald Temp_y den Wert 0 erreicht hat
			If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=1 Then	
				 ;berprft, ob sich ein Tile unter dem Spieler befindet
				jump = 0
				temp = Player_pos_y /32	;\
				Player_pos_y = temp *32	;/ Setzt die genaue Y-Position, falls die Figur mitten im Tile steht 
			EndIf
		EndIf
	 EndIf 
	
	;Gravity
	If jump = False  Then
		If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=0 Then	; Sollte kein Tile unter dem Spieler sein
			jump = True 		; Sprungfunktion weiter ausfhren
			Player_temp_y = 0	; Temp_y = 0, weil diese einen negativen Wert berechnen soll
		EndIf 
	EndIf 
	
	;sorgt dafr, das die Figur nicht aus den Himmel schiet
	If Player_pos_y =< 0 Then
		Player_pos_y = 1
		jump = True 
		Player_Temp_y = 0
	EndIf
	
	If Player_pos_y => 448 Then 
		Player_pos_y = 447 
		jump = False 
	EndIf 
		
End Function 
	


Function DrawPlayer()
	DrawImage dude, Player_pos_x, Player_pos_y
End Function 


.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0