;Tutorial 7. Leben und Punkte hinzufgen
;Soweit funktioniert schon alles recht gut, aber es fehlt noch die Abfrage, was passiert, wenn 
;der Spieler gegen ein Monster luft. Und was ist mit den Punkten? Kein Spiel ohne Belohnung :-). 


Graphics 640,480

SetBuffer BackBuffer()
frametimer = CreateTimer (30)
ClsColor 0, 0, 255


Global tile = LoadImage ("tile2.bmp")
MaskImage tile, 255, 0, 255

Global hero = LoadAnimImage ("dude2.bmp", 32, 32, 0, 8)
MaskImage hero, 255, 0, 255

Global bomb = LoadImage ("bomb.bmp")
MaskImage bomb, 255, 0, 255

Global Monster1 = LoadAnimImage ("monster1b.bmp", 32, 32, 0, 8)
Global Monster2 = LoadAnimImage ("monster2b.bmp", 32, 32, 0, 8)
MaskImage Monster1, 255, 0, 255
MaskImage Monster2, 255, 0, 255



Global Player_pos_x = 200
Global Player_pos_y = 320
Global Player_temp_y# = 0
Global Player_Counter = 8, Player_Frame = 0
Global Score = 0, Lives = -1 ; Zwei weitere Variablen mssen hinzugefgt werden.
								;Lives wird gleich von Anfang an auf -1 gesetzt, um ein Starten des
								;Spieles zu verhindern
Global jump
Global jumptimer#

Global Start = 0

Const rauf = 200, runter = 208, rechts = 205, links = 203, space = 57 



Global anzahl=0
Global info.bomb

Type bomb
Field Pos_x
Field Pos_y
End Type 


Global info2.Monster

Type Monster
Field Monstertype
Field Pos_x
Field Pos_y
Field Richtung
Field Animcounter
Field Frame 
End Type 

Dim map (20,15)


;Die Hauptschleife
Repeat


WaitTimer (frametimer)
;Die Anzahl der Leben abfragen.
If Lives = -1 Then ; sollte kein Leben vorhanden sein
	Cls 	;Bildschirm lschen
	Text 100, 100, "Press F1 to Play"	
	If KeyHit (59) Then 	;Sobald die Taste F1 gedrckt wird
		Lives = 3			;Lebenszahl auf 3 erhhen
		score = 0			;Punkte zurcksetzen
	EndIf
	
ElseIf Lives > -1 Then	;Sobald Punkte hher als -1 ist
	Cls
	If Start = 0 Then 	;Um die Leveldaten neu einzulesen, habe ich eine neue Function erstellt
		Start = 1			;Diese kann man spter erweitern um mehrere Level zu erstellen.
		SetupLevel()
	EndIf 
 
	DrawMap()
	Movehero()
	DoJump()
	DrawBomb()
	DrawPlayer()
	MoveMonster()
	DrawMonster()
	Collision()
	DrawPoints()
	CheckBombs()
EndIf 
Flip

Until KeyHit (1) 
End


;Functionen
Function DrawMap()
	For y = 0 To 14
		For x = 0 To 19
			If map(x,y) = 1 Then
				DrawImage tile, x*32, y*32
			EndIf 
		Next
	Next
End Function  


Function Movehero()
	If KeyDown(links) Then
		If Player_Frame <4 Then Player_Frame = 4
		Player_Counter = Player_Counter -1
		If Player_Counter = 0 Then
			Player_Counter = 8
			Player_Frame = Player_Frame +1
			If Player_Frame = 8 Then Player_Frame = 4
		EndIf 				
		If map(Player_pos_x /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x -4
			If Player_pos_x =< 0 Then Player_pos_x = 1
		EndIf
	ElseIf KeyDown(rechts) Then
		If Player_Frame >3 Then Player_Frame = 0
		Player_Counter = Player_Counter -1
		If Player_Counter = 0 Then
			Player_Counter = 8
			Player_Frame = Player_Frame +1
			If Player_Frame = 4 Then Player_Frame = 0
		EndIf 
		If map((Player_pos_x +32) /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x +4
			If Player_pos_x => 608 Then Player_pos_x = 607
		EndIf
	EndIf 
End Function 


	
Function DoJump()
	
	If KeyDown (space) Then
		If jump = False
			jump = True
			Player_temp_y = 15
			
		EndIf 
	EndIf
	
	
	If map((Player_pos_x +16) /32,Player_pos_y /32)=1 And jump = True Then
		jump = False
		Player_pos_y = Player_pos_y +1	
	EndIf 
	
	 
	 
	If jump = True Then
		Player_temp_y = Player_temp_y -0.33
		Player_pos_y = Player_pos_y - Player_temp_y
		If Player_temp_y =< 0 Then 
			If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=1 Then
				jump = 0
				temp = Player_pos_y /32
				Player_pos_y = temp *32
			EndIf
		EndIf
	 EndIf 
	
	
	If jump = False  Then
		If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=0 Then	
			jump = True 
			Player_temp_y = 0
		EndIf 
	EndIf 
	

	If Player_pos_y =< 0 Then
		Player_pos_y = 1
		jump = True 
		Player_Temp_y = 0
	EndIf
	
	If Player_pos_y => 448 Then 
		Player_pos_y = 447 
		jump = False 
	EndIf 
		
End Function 
	


Function DrawPlayer()
	DrawImage hero, Player_pos_x, Player_pos_y,Player_Frame
End Function 



Function DrawBomb()
	For info.bomb = Each bomb
		DrawImage bomb, info\Pos_x, info\Pos_y
	Next 
End Function 



Function DrawMonster()
	For info2.Monster = Each Monster
		If info2\Monstertype = 1 Then
			DrawImage Monster1, info2\Pos_x, info2\Pos_y, info2\frame
		ElseIf info2\Monstertype = 2 Then
			DrawImage Monster2, info2\Pos_x, info2\Pos_y, info2\frame
		EndIf 
	Next 
End Function 



Function MoveMonster()
	For info2.Monster = Each Monster
		If info2\Monstertype = 2 Then 
			If info2\Richtung = 1 Then 
				info2\Pos_x = info2\Pos_x +2
				If info2\Frame >3 Then info2\Frame = 0
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 4 Then info2\Frame = 0
				EndIf 
				If map((info2\Pos_x +16) /32,(info2\Pos_y +32) /32)=0 Then
					info2\Richtung = 0
				EndIf 
			ElseIf info2\Richtung = 0 Then 
				info2\Pos_x = info2\Pos_x -2
				If info2\Frame <4 Then info2\Frame = 4
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 8 Then info2\Frame = 4
				EndIf 
				If map((info2\Pos_x +16) /32,(info2\Pos_y +32) /32)=0 Then
					info2\Richtung = 1
				EndIf 			
			EndIf
	
		ElseIf info2\Monstertype = 1 Then
			If info2\Pos_x < Player_Pos_x Then
				info2\Pos_x = info2\Pos_x +1
				info2\Richtung = 1
			ElseIf info2\Pos_x > Player_Pos_x Then
				info2\Pos_x = info2\Pos_x -1
				info2\Richtung = 0
				If info2\Frame <4 Then info2\Frame = 4
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 8 Then info2\Frame = 4
				EndIf 				
			EndIf 
			If info2\Pos_y < Player_Pos_y Then
				info2\Pos_y = info2\Pos_y +1
			ElseIf info2\Pos_y > Player_Pos_y Then
				info2\Pos_y = info2\Pos_y -1
			EndIf
			
			If info2\Richtung = 1 Then
				If info2\Frame >3 Then info2\Frame = 0
		 		info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 4 Then info2\Frame = 0
				EndIf 
 			ElseIf info2\Richtung = 0
				If info2\Frame <4 Then info2\Frame = 4
				info2\Animcounter = info2\Animcounter -1
				If info2\Animcounter = 0 Then
					info2\Animcounter = 8
					info2\Frame = info2\Frame +1
					If info2\Frame = 8 Then info2\Frame = 4
				EndIf 				
			EndIf 
		EndIf
	Next
End Function 



Function Collision()
	
	For info.bomb = Each bomb
		If ImagesCollide (bomb, info\Pos_x, info\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
			Delete info.bomb
			AddPoints(50) ;Punkte um die angegebene Anzahl erhhen
		EndIf
	Next
	

	For info2.Monster = Each Monster
		If info2\Monstertype = 1 Then 
			If ImagesCollide (Monster1, info2\Pos_x, info2\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
				Lives = Lives -1	;Leben um einz veringern
				Start = 0			;Level neu aufbauen
				Delay 1000			;kurze Pause
				Delete Each monster
				Player_pos_x = 200	;Spielerwerte zurcksetzen
				Player_pos_y = 320
				Player_temp_y# = 0
				Player_Counter = 8
				Player_Frame = 0
			EndIf 
		ElseIf info2\Monstertype = 2 Then
			If ImagesCollide (Monster2, info2\Pos_x, info2\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
				Lives = Lives -1
				Start = 0
				Delay 1000
				Delete Each monster
				Player_pos_x = 200
				Player_pos_y = 320
				Player_temp_y# = 0
				Player_Counter = 8
				Player_Frame = 0
			EndIf 		 	
		EndIf
	Next
End Function 


;Function um die Punkte zu erhhen
Function AddPoints (pnts)
	t = score / 5000		;Die Punkte werden durch 5000 geteilt und in eine Variable geschrieben
							;dabei handelt es sich um eine Variable mit einer Ganzzahl. Die Kommawerte
							;werden deshalb einfach abgeschnitten 
	score = score + pnts	;bergebener Wert den Punkten hinzufgen
	If score / 5000 <> t Then Lives = Lives +1	;berprft, ob die Punkte hher als die Vorherigen sind
													;und erhht bei bedarf die Anzahl der Leben.
End Function 



Function DrawPoints()	;Zeichnet den Punktestand und die Leben auf den Bildschirm
	Text 10 ,10, "Lives :"
	Text 80 ,10, Lives
	Text 300,10, "Score :"
	Text 380,10, score
End Function 


;Diese Funktion berprft, ob noch Bomben vorhanden sind
Function CheckBombs()
	info.bomb = First bomb ;erste Bombe abfragen
	If info.bomb = Null Then ;sollte diese nicht vorhanden sein
		pnts= 500:AddPoints(pnts)	;Punkte um 500 erhhen
		Start = 0						;Level neu zeichnen.
		;Hier knnte man spter auch den Level erhhen, so das der nchste gewnschte geladen wird.
		Delete Each monster	;Monster lschen
	EndIf 
End Function 


;Diese Function ist ntig geworden,um die Karte mit Ihren Gegnern und Bomben immer wieder neu aufzubauen.
Function SetupLevel()

	;Kartendaten lesen
	Restore mapdata
	For y=0 To 14
		For x=0 To 19
			Read map(x,y)
		Next
	Next
	
	
	;Bombendaten lesen
	Restore bomb_level1
	Read anzahl
	For i = 1 To anzahl
		info.bomb = New bomb
		Read x, y
		info\Pos_x = x
		info\Pos_Y = y
	Next 		
	
	;Gegnerdaten lesen
	Restore monster_level1
	Read anzahl
	For i = 1 To anzahl
		info2.Monster = New Monster
		Read Monstertype, x, y, richtung,counter,frame
		info2\Monstertype = Monstertype
		info2\Pos_x = x
		info2\Pos_y = y
		info2\Richtung = Richtung
		info2\Animcounter = counter
		info2\Frame = frame
	Next 		
End Function 

.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.bomb_level1
Data 25
Data 32,64
Data 64,64
Data 96,64
Data 128,64
Data 160,64
Data 448,64
Data 480,64
Data 512,64
Data 544,64
Data 576,64
Data 224,192
Data 256,192
Data 288,192
Data 320,192
Data 352,192
Data 32,320
Data 64,320
Data 96,320
Data 128,320
Data 160,320
Data 448,320
Data 480,320
Data 512,320
Data 544,320
Data 576,320

;Monster,x,y,richtung,counter,frame
.monster_level1
Data 6
Data 1, 32, 32, 1, 8, 0
Data 2, 96, 64, 1, 8, 0
Data 2, 512, 64, 0, 8, 4
Data 2, 288, 192, 1, 8, 0
Data 2, 96, 320, 1, 8, 0
Data 2, 512, 320, 0, 8, 4