;Tutorial 1: Erstellen der Level
;-------------------------------
;In diesem Teil mchte ich erklren, wie Level erstellt und auf den Bildschirm 
;gebracht wird. Zustzlich habe ich noch einige Kommentare zu den Befehlen eingegeben.

Graphics 640,480	
		
SetBuffer BackBuffer()	
frametimer = CreateTimer (30)	;Um das Spiel auf alle Rechnerkonfigurationen gleich schnell laufen
									; lassen, sollte man einen Zeitgeber setzen. 25 - 60 sind Empfehlenswert.
									 
ClsColor 0, 0, 255	; Farbe, mit dem der Bildschirm gelscht wird

;Gfx laden
Global tile = LoadImage ("tile2.bmp")
MaskImage tile, 255, 0, 255	;Setzt die transparente Farbe auf Lila


;Kartendaten lesen 
Dim map (20,15)	;Karte definieren. Da die Karte spter nach X und Y Koordinaten gezeichnet wird,
					;2 dimensionanes Array

Restore mapdata	;Setzt die Datazeilen von mapdata zurck
For y=0 To 14		;Y = 15. Von 0 bis 14
	For x=0 To 19	;X = 20.
		Read map(x,y)	;Daten auslesen
	Next
Next


;Hauptschleife
Repeat
Cls							;Bildschirm lschen
WaitTimer (frametimer)	;Den gewhlten Zeitgeber warten

DrawMap()					;Function Drawmap ausfhren

Flip						;Bildschirm tauschen

Until KeyHit (1) 
End


;Functionen
Function DrawMap()
	For y = 0 To 14
		For x = 0 To 19
			If map(x,y) = 1 Then				;ist in dem genannten (x,y) Array eine 1 gemerkt,
				DrawImage tile, x*32, y*32	;Grafik malen.
			EndIf 
		Next
	Next
End Function  

;Die Koordinaten der Karte werden hier gelesen
.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0