;Tutorial 2. Hinzufgen einer Spielfigur inklusiv Begrenzungen
;Nachdem wir den Level auf dem Bildschirm gemalt hatten, wollen wir auch eine Spielfigur hinzufgen.
;Ebenfalls mssen wir Begrenzungen fr die Rnder setzen und die Kollisionen mit der Plattform testen.
;Weil diese Kollisionsabfrage in greren Level ziemlich umstndlich werden kann, berprfen wir nur, 
;welche Tiles (Grafiken) um den Spieler herum existieren. 

Graphics 640,480

SetBuffer BackBuffer()
frametimer = CreateTimer (30)
ClsColor 0, 0, 255

;Gfx laden
Global tile = LoadImage ("tile2.bmp")
MaskImage tile, 255, 0, 255
Global dude = LoadImage ("dude.bmp")	;Die Spielfigur laden und ebenfalls die Transparente Farbe setzen.
MaskImage dude, 255, 0, 255

;Variablen und Constante bestimmen
Global Player_pos_x = 200	;Spielekoordinaten setzen. Um die Variablen in den Routinen benutzen zu
Global Player_pos_y = 320	;knnen, mssen diese Globalisiert werden

;Um die Cursorsteuerung etwas zu vereinfachen, habe ich die Werte gleich in 
;Constante (unvernderbare) Variablen gespeichert.
Const rauf = 200, runter = 208, rechts = 205, links = 203, space = 57 



;Kartendaten lesen 
Dim map (20,15)

Restore mapdata
For y=0 To 14
	For x=0 To 19
		Read map(x,y)
	Next
Next


;Hauptschleife
Repeat
Cls
WaitTimer (frametimer)

DrawMap()	;Karte malen
MoveDude()	;Figur berechnen

DrawImage dude, Player_pos_x, Player_pos_y	;Figur zeichnen

Flip

Until KeyHit (1) 
End


;Functionen
Function DrawMap()
	For y = 0 To 14
		For x = 0 To 19
			If map(x,y) = 1 Then
				DrawImage tile, x*32, y*32
			EndIf 
		Next
	Next
End Function  


Function MoveDude()			;Function um die Figur zu bewegen
	If KeyDown(links) Then        ;Falls links gedrckt wird
		If map(Player_pos_x /32,(Player_pos_y +16) /32)=0 Then
			 ;wenn Spielerposition / 32, weil die Tiles 32 * 32 gro sind
			 ;PosY +16 um die Mitte zu bestimmen
			 ;If Bedinung wird nur ausgefhrt, wenn kein Tile neben der Figur ist.
			Player_pos_x = Player_pos_x -4      ; X-Position -4
			If Player_pos_x =< 0 Then Player_pos_x = 1       ;Rand berprfen
		EndIf
	ElseIf KeyDown(rechts) Then
		If map((Player_pos_x +32) /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x +4
			If Player_pos_x => 608 Then Player_pos_x = 607
		EndIf
	ElseIf KeyDown(rauf) Then
		If map((Player_pos_x +16) /32,Player_pos_y /32)=0 Then
			Player_pos_y = Player_pos_y -4
			If Player_pos_y =< 0 Then Player_pos_y = 1
		EndIf		
	ElseIf KeyDown(runter) Then
		If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=0 Then
			Player_pos_y = Player_pos_y +4
			If Player_pos_y => 448 Then Player_pos_y = 447
		EndIf		
	EndIf
End Function 

.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
