;Tutorial 4 hinzufgen von Bomben zum einsammeln, inclusive Collisionsabfrage
; In diesem Teil wollen wir Gegenstnde zum einsammeln auf den Bildschirm bringen
; und Ihre Kollision mit dem Spieler abfragen.


Graphics 640,480

SetBuffer BackBuffer()
frametimer = CreateTimer (30)
ClsColor 0, 0, 255


Global tile = LoadImage ("tile2.bmp")
MaskImage tile, 255, 0, 255

Global hero = LoadImage ("dude.bmp")
MaskImage hero, 255, 0, 255

Global bomb = LoadImage ("bomb.bmp")	;eine neue Grafig wird geladen
MaskImage bomb, 255, 0, 255



Global Player_pos_x = 200
Global Player_pos_y = 320
Global Player_temp_y# = 0
Global jump
Global jumptimer#

Const rauf = 200, runter = 208, rechts = 205, links = 203, space = 57 


;Types fr die Bomben
Global anzahl=0
Global info.bomb

Type bomb
Field Pos_x
Field Pos_y
End Type 


 
Dim map (20,15)

Restore mapdata
For y=0 To 14
	For x=0 To 19
		Read map(x,y)
	Next
Next


;Bombendaten lesen
Restore bomb_level1
Read anzahl	;der erste Wert in der Dataschleife gibt die Anzahl der Bomben an 
For i = 1 To anzahl		;Zhlt durch die einzelnen Eintrge  
	info.bomb = New bomb	;Neue Bombe erstellen
	Read x, y				;Koordinaten lesen
	info\Pos_x = x			;x und y Werte an dem Typ bergeben
	info\Pos_Y = y
Next 		


; Die Hauptschleife
Repeat

Cls
WaitTimer (frametimer)

DrawMap()
Movehero()
DoJump()
DrawBomb()
DrawPlayer()
Collision()

Flip

Until KeyHit (1) 
End


;Functionen
Function DrawMap()
	For y = 0 To 14
		For x = 0 To 19
			If map(x,y) = 1 Then
				DrawImage tile, x*32, y*32
			EndIf 
		Next
	Next
End Function  


Function Movehero()
	If KeyDown(links) Then	
		If map(Player_pos_x /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x -4
			If Player_pos_x =< 0 Then Player_pos_x = 1
		EndIf
	ElseIf KeyDown(rechts) Then
		If map((Player_pos_x +32) /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x +4
			If Player_pos_x => 608 Then Player_pos_x = 607
		EndIf
	EndIf 
End Function 


	
Function DoJump()
	
	If KeyDown (space) Then
		If jump = False
			jump = True
			Player_temp_y = 15
		EndIf 
	EndIf
	
	
	If map((Player_pos_x +16) /32,Player_pos_y /32)=1 And jump = True Then
		jump = False
		Player_pos_y = Player_pos_y +1	
	EndIf 
	
	 
	 
	If jump = True Then
		Player_temp_y = Player_temp_y -0.33
		Player_pos_y = Player_pos_y - Player_temp_y
		If Player_temp_y =< 0 Then 
			If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=1 Then
				jump = 0
				temp = Player_pos_y /32
				Player_pos_y = temp *32
			EndIf
		EndIf
	 EndIf 
	
	
	If jump = False  Then
		If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=0 Then	
			jump = True 
			Player_temp_y = 0
		EndIf 
	EndIf 
	
	
	If Player_pos_y =< 0 Then
		Player_pos_y = 1
		jump = True 
		Player_Temp_y = 0
	EndIf
	
	If Player_pos_y => 448 Then 
		Player_pos_y = 447 
		jump = False 
	EndIf 
		
End Function 
	


Function DrawPlayer()
	DrawImage hero, Player_pos_x, Player_pos_y
End Function 


; Die Bomben malen
Function DrawBomb()
	For info.bomb = Each bomb					; Alle Bomben abfragen
		DrawImage bomb, info\Pos_x, info\Pos_y	;Bomben malen
	Next 
End Function 


;Function um die Kollision zwischen den Bomben und der Figur zu testen
Function Collision()
	For info.bomb = Each bomb	;Alle Bomben abfragen
		If ImagesCollide (bomb, info\Pos_x, info\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
			;Sobald eine Kollision auftritt
			Delete info.bomb	; Bombe lschen
		EndIf
	Next
End Function 

.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; Hier sind die Daten abgelegt, die zur Positionierung der Bomben notwendig sind
.bomb_level1
Data 25
Data 32,64
Data 64,64
Data 96,64
Data 128,64
Data 160,64
Data 448,64
Data 480,64
Data 512,64
Data 544,64
Data 576,64
Data 224,192
Data 256,192
Data 288,192
Data 320,192
Data 352,192
Data 32,320
Data 64,320
Data 96,320
Data 128,320
Data 160,320
Data 448,320
Data 480,320
Data 512,320
Data 544,320
Data 576,320