;Tutorial 5. Einfgen von Gegnern
; Um das Spiel nicht viel zu einfach zu machen mchte ich nun die Gegner einfgen.
; Es sollen zwei verschiedene Gegner entstehen. Einige, die auf den Platformen hin
; und her laufen und ein Gegner, der den Spieler verfolgt.


Graphics 640,480

SetBuffer BackBuffer()
frametimer = CreateTimer (30)
ClsColor 0, 0, 255


Global tile = LoadImage ("tile2.bmp")
MaskImage tile, 255, 0, 255

Global hero = LoadImage ("dude.bmp")
MaskImage hero, 255, 0, 255

Global bomb = LoadImage ("bomb.bmp")
MaskImage bomb, 255, 0, 255

;Neue Grafiken fr die Gegner wird geladen
Global Monster1 = LoadImage ("monster1.bmp")
Global Monster2 = LoadImage ("monster2.bmp")
MaskImage Monster1, 255, 0, 255
MaskImage Monster2, 255, 0, 255



Global Player_pos_x = 200
Global Player_pos_y = 320
Global Player_temp_y# = 0
Global jump
Global jumptimer#

Const rauf = 200, runter = 208, rechts = 205, links = 203, space = 57 



Global anzahl=0
Global info.bomb

Type bomb
Field Pos_x
Field Pos_y
End Type 

;Types fr die Gegner
Global info2.Monster

Type Monster
Field Monstertype
Field Pos_x
Field Pos_y
Field Richtung
End Type 

 
Dim map (20,15)

Restore mapdata
For y=0 To 14
	For x=0 To 19
		Read map(x,y)
	Next
Next



Restore bomb_level1
Read anzahl
For i = 1 To anzahl
	info.bomb = New bomb
	Read x, y
	info\Pos_x = x
	info\Pos_Y = y
Next 		

;Gegnerdaten lesen
Restore monster_level1
Read anzahl	; der erste Wert in der Data Schleife
For i = 1 To anzahl						;Zhlt durch die einzelnen Eintrge
	info2.Monster = New Monster			;Neue Gegner erstellen
	Read Monstertype, x, y, richtung	;Typen, Koordinaten und Startrichtung lesen
	info2\Monstertype = Monstertype		;Die gelesenen Werte bergeben
	info2\Pos_x = x
	info2\Pos_y = y
	info2\Richtung = Richtung
Next 		

;Die Hauptschleife
Repeat

Cls
WaitTimer (frametimer)

DrawMap()
Movehero()
DoJump()
DrawBomb()
DrawPlayer()
MoveMonster()
DrawMonster()
Collision()

Flip

Until KeyHit (1) 
End


;Functionen
Function DrawMap()
	For y = 0 To 14
		For x = 0 To 19
			If map(x,y) = 1 Then
				DrawImage tile, x*32, y*32
			EndIf 
		Next
	Next
End Function  


Function Movehero()
	If KeyDown(links) Then	
		If map(Player_pos_x /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x -4
			If Player_pos_x =< 0 Then Player_pos_x = 1
		EndIf
	ElseIf KeyDown(rechts) Then
		If map((Player_pos_x +32) /32,(Player_pos_y +16) /32)=0 Then
			Player_pos_x = Player_pos_x +4
			If Player_pos_x => 608 Then Player_pos_x = 607
		EndIf
	EndIf 
End Function 


	
Function DoJump()
	
	If KeyDown (space) Then
		If jump = False
			jump = True
			Player_temp_y = 15
		EndIf 
	EndIf
	
	
	If map((Player_pos_x +16) /32,Player_pos_y /32)=1 And jump = True Then
		jump = False
		Player_pos_y = Player_pos_y +1	
	EndIf 
	
	 
	 
	If jump = True Then
		Player_temp_y = Player_temp_y -0.33
		Player_pos_y = Player_pos_y - Player_temp_y
		If Player_temp_y =< 0 Then 
			If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=1 Then
				jump = 0
				temp = Player_pos_y /32
				Player_pos_y = temp *32
			EndIf
		EndIf
	 EndIf 
	
	
	If jump = False  Then
		If map((Player_pos_x +16) /32,(Player_pos_y +32) /32)=0 Then	
			jump = True 
			Player_temp_y = 0
		EndIf 
	EndIf 
	
	If Player_pos_y =< 0 Then
		Player_pos_y = 1
		jump = True 
		Player_Temp_y = 0
	EndIf
	
	If Player_pos_y => 448 Then 
		Player_pos_y = 447 
		jump = False 
	EndIf 
		
End Function 
	


Function DrawPlayer()
	DrawImage hero, Player_pos_x, Player_pos_y
End Function 



Function DrawBomb()
	For info.bomb = Each bomb
		DrawImage bomb, info\Pos_x, info\Pos_y
	Next 
End Function 


;Function Monster malen.
Function DrawMonster()
	For info2.Monster = Each Monster	;Alle Monster abfragen
		If info2\Monstertype = 1 Then	;Wenn es der erste Monstertyp ist
			DrawImage Monster1, info2\Pos_x, info2\Pos_y	;Monster malen
		ElseIf info2\Monstertype = 2 Then	;Wenn es der zweite ist
			DrawImage Monster2, info2\Pos_x, info2\Pos_y	;Monster malen
		EndIf 
	Next 
End Function 


;Function um die Monster zu bewegen
Function MoveMonster()
	For info2.Monster = Each Monster	;alle Monster abfragen
		If info2\Monstertype = 2 Then 	; wenn Monstertyp 2
			If info2\Richtung = 1 Then 	; Richtung abfragen
				info2\Pos_x = info2\Pos_x +2	;X-Position erhhen
				If map((info2\Pos_x +16) /32,(info2\Pos_y +32) /32)=0 Then	
				; sollte keine Tile mehr unter dem Monster sein
					info2\Richtung = 0	;umkehren
				EndIf 
			ElseIf info2\Richtung = 0 Then ;andere Richtung?
				info2\Pos_x = info2\Pos_x -2
				If map((info2\Pos_x +16) /32,(info2\Pos_y +32) /32)=0 Then
					info2\Richtung = 1
				EndIf 			
			EndIf
		ElseIf info2\Monstertype = 1 Then	; Sollte es der erste Monstertyp sein
			If info2\Pos_x < Player_Pos_x Then	;Sobald die X Position des Monsters kleiner als die des Spielers sein
				info2\Pos_x = info2\Pos_x +1		;X-Position erhhen
				info2\Richtung = 1				;Die Richtung in die geschaut werden soll (gibt erst spter einen Sinn)
			ElseIf info2\Pos_x > Player_Pos_x Then	;oder X-Pos grer als die des Spielers
				info2\Pos_x = info2\Pos_x -1		;X erniedrigen
				info2\Richtung = 0				
			EndIf 
			If info2\Pos_y < Player_Pos_y Then	;Das selbe gilt fr die Y-Position
				info2\Pos_y = info2\Pos_y +1
			ElseIf info2\Pos_y > Player_Pos_y Then
				info2\Pos_y = info2\Pos_y -1
			EndIf 
		EndIf
	Next
End Function 



Function Collision()
	;Einsammeln der Bomben
	For info.bomb = Each bomb
		If ImagesCollide (bomb, info\Pos_x, info\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
			Delete info.bomb
		EndIf
	Next
	
	;Collision mit den Monstern
	For info2.Monster = Each Monster	;Alle Monster abfragen
		If info2\Monstertype = 1 Then 	;Wenn Typ 1
			If ImagesCollide (Monster1, info2\Pos_x, info2\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
				Text 100,100, "Leben verloren 1" ; wenn collidiert, erscheint dieser Text
			EndIf 
		ElseIf info2\Monstertype = 2 Then ;Oder Typ 2
			If ImagesCollide (Monster2, info2\Pos_x, info2\Pos_y, 0, hero, Player_pos_x, Player_pos_y, 0) Then 
				Text 100,100, "Leben verloren 2"
			EndIf 		 	
		EndIf
	Next
End Function 



.mapdata
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.bomb_level1
Data 25
Data 32,64
Data 64,64
Data 96,64
Data 128,64
Data 160,64
Data 448,64
Data 480,64
Data 512,64
Data 544,64
Data 576,64
Data 224,192
Data 256,192
Data 288,192
Data 320,192
Data 352,192
Data 32,320
Data 64,320
Data 96,320
Data 128,320
Data 160,320
Data 448,320
Data 480,320
Data 512,320
Data 544,320
Data 576,320

;hnlich wie bei den Bomben, habe ich hier die Daten fr die Monster abgelegt. 
;Data = Monstertype ,x ,y , Richtung
.monster_level1
Data 6
Data 1, 32, 32, 1
Data 2, 96, 64, 1
Data 2, 512, 64, 0
Data 2, 288, 192, 1
Data 2, 96, 320, 1
Data 2, 512, 320, 0